#pragma once

#include "aicomponent.h"

enum AndroidState_e
{
   AS_thinking,
   AS_moving,
   AS_attack
};

class Human;
class AndroidAI : public AIComponent
{
 public:
    AndroidState_e state = AS_thinking;
    int state_elapsed_time = 0;
    Human* last_hiter = nullptr;

    virtual ~AndroidAI() override;
    virtual void Update(int delta_time) override;

private:
    void UpdateNewBieNpc();
    void UpdateLastNpc();
    void UpdateNewBieRoomLogic();

    void ChangeToState(AndroidState_e to_state);

    void DoMove();
    void DoAttack();

private:
    Human* last_target_ = nullptr;
    long long last_attack_frameno_ = 0;
    long long last_findenemy_frameno_ = 0;
    long long series_attack_frames_ = 0;
};
